from twisted.internet import reactor
from twisted.python import log
import habu

import sys

def usage(name):
    print "Usage : %s [config_file_path]" % name

def main(*args):
    import getopt
    import os.path
    cfgFile = "habu.cfg"
    opts, args = getopt.gnu_getopt(args[1:], "")
    if args:
        cfgFile = args[0]
    if not os.path.exists(cfgFile):
        usage(arg[0])
        return

    mgr = habu.Habu()
    mgr.load(open(cfgFile).read())
    mgr.startLogging()
    
    if not mgr.getPipelines():
        return
    if not mgr.scheduler:
        allManagers = mgr.runAll()
        def eventFired(firedManager):
            if firedManager.executeContexts:
                return
            allManagers.remove(firedManager)
            if not allManagers:
                log.msg("Stopping reactor")
                reactor.stop()
        for m in allManagers:
            m.addHook(m.HOOK_TYPE_SUCCESS, eventFired)
            m.addHook(m.HOOK_TYPE_GOT_ERROR, eventFired)
    else:
        mgr.startScheduler()
    reactor.run()
    

if __name__ == "__main__":
    main(*(sys.argv))
